module Main exposing (main)
import SeqSim.Model exposing (Model, Msg, Flags, begin)
import SeqSim.Render exposing (view)
import SeqSim.Update exposing (update)
import Browser exposing (Document, document)

init : Flags -> (Model, Cmd Msg)
init f = (begin, Cmd.none)

view : Model -> Document Msg
view m =
    { title = "Sequential Consistency Explorer"
    , body = SeqSim.Render.view m
    }

update : Msg -> Model -> (Model, Cmd Msg)
update = SeqSim.Update.update

subscriptions : Model -> Sub Msg
subscriptions m = Sub.none

main = document
    { init = init
    , view = view
    , update = update
    , subscriptions = subscriptions
    }
